unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, jcode, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Bevel1: TBevel;
    Label7: TLabel;
    Edit1: TEdit;
    ComboBox1: TComboBox;
    Label6: TLabel;
    ComboBox2: TComboBox;
    Button1: TButton;
    Bevel2: TBevel;
    Label9: TLabel;
    Label8: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  strVersion: String;
  lpSource: array of Char;
  FS: TFileStream;
  intCode: Integer;
begin
    // o[W
    SetLength(strVersion, JcodeVersion);
    JcodeVersion(strVersion);
    Label9.Caption := strVersion;

    // uϊt@Cv
    Label2.Caption := ParamStr(1);

    // uϊt@Cv
    Edit1.Text := ParamStr(1) + '.conv';

    // uϊR[hv
    ComboBox1.Items.Add('JC_UNKNOWN');
    ComboBox1.Items.Add('JC_SJIS');
    ComboBox1.Items.Add('JC_JIS');
    ComboBox1.Items.Add('JC_EUC');

    // uϊR[hv
    ComboBox2.Items.Add('JC_SJIS');
    ComboBox2.Items.Add('JC_JIS');
    ComboBox2.Items.Add('JC_EUC');
    ComboBox2.ItemIndex := 0;

    // ϊt@CǍ
    FS := TFileStream.Create(ParamStr(1), FmOpenRead or fmShareDenyNone);
    Label4.Caption := IntToStr(FS.Size);    // ut@CTCYv
    SetLength(lpSource, FS.Size + 1);
    FS.Read(lpSource[0], FS.Size + 1);
    lpSource[FS.Size] := Chr(0);            // kt
    FS.Free;

    // R[h
    intCode := JcodeDetect(PByteArray(lpSource));
    case intCode of
      JC_UNKNOWN: ComboBox1.ItemIndex := 0;
      JC_SJIS:    ComboBox1.ItemIndex := 1;
      JC_JIS:     ComboBox1.ItemIndex := 2;
      JC_EUC:     ComboBox1.ItemIndex := 3;
    else
                  ComboBox1.ItemIndex := -1;
    end;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  intSource, intDest: Integer;
  lpSource, lpDest: array of Char;
  FS: TFileStream;
  intBufSize: Integer;
begin
    // uϊR[hv
    case ComboBox1.ItemIndex of
      0: begin
             Beep;
             MessageDlg(#13#10 + 'ϊR[hw肵Ă', mtWarning, [mbOk], 0);
             exit;
         end;
      1: intSource := JC_SJIS;
      2: intSource := JC_JIS;
      3: intSource := JC_EUC;
    end;

    // uϊR[hv
    case ComboBox2.ItemIndex of
      0: intDest := JC_SJIS;
      1: intDest := JC_JIS;
      2: intDest := JC_EUC;
    end;

    // ϊt@CǍ
    FS := TFileStream.Create(ParamStr(1), FmOpenRead or fmShareDenyNone);
    SetLength(lpSource, FS.Size + 1);
    FS.Read(lpSource[0], FS.Size + 1);
    lpSource[FS.Size] := Chr(0);    // kt
    FS.Free;

    // R[hϊ
    intBufSize := JcodeConvert(intSource, intDest, PByteArray(lpSource));
    SetLength(lpDest, intBufSize);
    JcodeConvert(intSource, intDest, PByteArray(lpSource), PByteArray(lpDest));

    // ϊt@C
    FS := TFileStream.Create(Edit1.Text, fmCreate or fmShareExclusive);
    FS.Write(lpDest[0], intBufSize - 1);    // k폜
    FS.Free;

    // ϊ
    MessageDlg(#13#10'ϊ', mtInformation, [mbOk], 0);
end;

end.
