unit jcode;

interface

uses
  Windows, SysUtils;

const JC_ERROR = 0;

const JC_UNKNOWN = 0;
const JC_SJIS = 4;
const JC_JIS  = 8;
const JC_EUC  = 12;

function JcodeVersion(lpBuffer: String=''): Integer; stdcall; external 'jcode.dll';
function JcodeDetect(lpString: PByteArray; intDefault: Integer=JC_UNKNOWN): Integer; stdcall; external 'jcode.dll';
function JcodeConvert(intSource, intDest: Integer; lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';

function JcodeEucToJis(lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';
function JcodeEucToSjis(lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';
function JcodeJisToEuc(lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';
function JcodeJisToSjis(lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';
function JcodeSjisToEuc(lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';
function JcodeSjisToJis(lpSource: PByteArray; lpDest: PByteArray=nil): DWORD; stdcall; external 'jcode.dll';

implementation

end.
